'''
@author: jose.corsini
'''
from util.FundCalculatedDataItem import FundCalculatedDataItem
import util
from analysis import SearchProcessor
from calculators import Calculator 

#Computa os indicadores precalculados no sistema
def computeCalculatedIndicators(date): 
    
    cnpjList = util.buscaListaCNPJTodosFundos()
    
    for cnpj in cnpjList:
        fundContainer = SearchProcessor.searchFund(cnpj)
        fundCalculatedData = util.findCalculatedDataByFundDate(fundContainer.fund.fundId, date)
        if(fundCalculatedData == None):
            benchContainer = SearchProcessor.searchBenchmark('IBOVESPA')
            if(benchContainer == None):
                print 'CONTAINER NAO ENCONTRADO'
                return
            util.persistCalculatedData(fundContainer.fund.fundId, date)
            fundCalculatedData = util.findCalculatedDataByFundDate(fundContainer.fund.fundId, date)
            computeAllIndicatorsForFund(fundCalculatedData, fundContainer, benchContainer)
        else:
            print 'JA ESTA CALCULADO PRO FUNDO: ', cnpj
        
    return 'CALCULADO COM SUCESSO'
    
    
#Computa todos indicadores para um determinado fundo
def computeAllIndicatorsForFund(fundCalculatedData, fundContainer, benchContainer):
    computeIndicatorForAllPeriods(fundCalculatedData, FundCalculatedDataItem.IndicatorType.RETORNO, fundContainer, None)
    computeIndicatorForAllPeriods(fundCalculatedData, FundCalculatedDataItem.IndicatorType.VOLATILIDADE, fundContainer, None)
    computeIndicatorForAllPeriods(fundCalculatedData, FundCalculatedDataItem.IndicatorType.BETA, fundContainer, benchContainer)

   
#Comouta todos os indicadores para todos os periodos
def computeIndicatorForAllPeriods(fundCalculatedData, indicatorType, fundContainer, benchContainer):
    computeIndicatorForTypeAndPeriod(fundCalculatedData,indicatorType, FundCalculatedDataItem.PeriodType.UM_MES, fundContainer, benchContainer)
    computeIndicatorForTypeAndPeriod(fundCalculatedData,indicatorType, FundCalculatedDataItem.PeriodType.TRES_MESES, fundContainer, benchContainer)
    computeIndicatorForTypeAndPeriod(fundCalculatedData,indicatorType, FundCalculatedDataItem.PeriodType.SEIS_MESES, fundContainer, benchContainer)
    computeIndicatorForTypeAndPeriod(fundCalculatedData,indicatorType, FundCalculatedDataItem.PeriodType.UM_ANO, fundContainer, benchContainer)

#Computa um indicador para um tipo e periodo
def computeIndicatorForTypeAndPeriod(fundCalculatedData, indicatorType, periodType, fundContainer, benchContainer):
    calculatedIndicator = Calculator.computeIndicator(fundContainer, benchContainer, fundCalculatedData, indicatorType, periodType)
    if(calculatedIndicator != None):
        persistCalculatedIndicator(calculatedIndicator)

#Persiste
def persistCalculatedIndicator(calculatedIndicator):
    util.persistCalculatedIndicator(calculatedIndicator)


    