'''
@author: jose.corsini
'''
from web import UserFilesController
from datetime import datetime, date
import util
from analysis import ReportOutputItem
from ReportOutputItem import ReportOutputItem
from util.FundCalculatedDataItem import FundCalculatedDataItem
from analysis.ReportOutput import ReportOutput
from util import AnalysisExporter

#Processa um relatorio de um usuario
def processReport(username):
    items = []
    f = open(UserFilesController.getReportParametersUploadedFilePath(username), 'r')
    lines = f.readlines()
    f.close()
    
    size = len(lines)
    d = datetime.strptime(lines[0].split(';')[0],"%Y-%m-%d")
    #d = date(2010,9,30)
    indicators = getIndicatorsList(lines[1].split(';'))
    periods = getPeriodsList(lines[2].split(';'))
    
   
    i = 3
    finalList = []
    while(i < size):
        cnpj = lines[i]
        f = util.buscaFundo(cnpj)
        calculatedData = util.findCalculatedDataByFundDate(f.fundId, d)
        if(calculatedData == None):
            i = i + 1
            continue
        items = util.searchFundCalculatedDataItemsByData(calculatedData)
        filterItems(finalList, items, periods, indicators, f)
        i = i + 1
    
    
    outputContainer = ReportOutput(username, lines[0], lines[1], lines[2], finalList)
    AnalysisExporter.exportReport(username, outputContainer)
    return outputContainer

#Filtra os itens de acordo com os parametros
def filterItems(finalList, items, periods, indicators, f):
    for it in items:
        if((it.indicatorType in indicators) and (int(it.periodType) in periods)):
            finalList.append(ReportOutputItem(f.cnpj, it))

#Interpreta a lista de periodos
def getPeriodsList(periodList):
    finalList = []
    for per in periodList:
        if(per == '1M'):
            finalList.append(FundCalculatedDataItem.PeriodType.UM_MES)
        elif(per == '3M'):
            finalList.append(FundCalculatedDataItem.PeriodType.TRES_MESES)
        elif(per == '6M'):
            finalList.append(FundCalculatedDataItem.PeriodType.SEIS_MESES)
        elif(per == '1A'):
            finalList.append(FundCalculatedDataItem.PeriodType.UM_ANO)
    
    return finalList    

#Intepreta a lista de indicadores
def getIndicatorsList(indicatorsList):
    finalList = []
    for ind in indicatorsList:
        if(ind == 'RETORNO'):
            finalList.append(FundCalculatedDataItem.IndicatorType.RETORNO)
        elif(ind == 'VOLATILIDADE'):
            finalList.append(FundCalculatedDataItem.IndicatorType.VOLATILIDADE)
        elif(ind == 'BETA'):
            finalList.append(FundCalculatedDataItem.IndicatorType.BETA)
    
    return finalList


    
    