'''
@author: jose.corsini
'''
#Classe que representa o calculo do Beta
from calculators import Return
import numpy

#Calcula o indicador Beta
def compute(fundContainer, benchContainer, periodType, date, window):
    
    fundRet = Return.computeSerie(fundContainer, benchContainer, periodType, date, 1)
    benchRet = Return.computeBenchSerie(fundContainer, benchContainer, periodType, date, 1)
    beta = computeBeta(fundRet.values, benchRet.values)
    return beta
 
#Calcula o indicador a partir dos retornos do fundo e do benchmark
def computeBeta(fundRet, benchRet):
    
    if(len(fundRet) != len(benchRet)):
        print 'ERRO NO TAMANHO DAS AMOSTRAS'
        return
    
    size = len(fundRet)
    fundAv = numpy.average(fundRet)
    benchAv = numpy.average(benchRet)
    
    #COVAR
    covar = 0.0
    #VAR
    var = 0.0
    
    
    for i in range(len(fundRet)):
        benchValue = benchRet[i]
        #COVAR
        covar = covar + (fundRet[i] - fundAv) * (benchValue - benchAv)
        #VAR
        var = var + (benchValue - benchAv) * (benchValue - benchAv)
        
    #COVAR
    covar = covar / size
    #VAR
    var =  var / (size -1)
    
    beta = covar / var
    return beta
