'''
@author: jose.corsini
'''
from util.FundCalculatedDataItem import FundCalculatedDataItem
from calculators import Return, StandardDeviation, Beta
 
#Classe que concentra as chamadas de calculos dos indicadores
def computeIndicator(fundContainer, benchContainer, fundCalculatedData, indicatorType, periodType):
    
    benchId = None
    if(benchContainer != None):
        benchId = benchContainer.bench.benchId
    
    value = None
    if(indicatorType == FundCalculatedDataItem.IndicatorType.RETORNO):
        value = Return.compute(fundContainer, benchContainer, periodType, fundCalculatedData.date)
    elif(indicatorType == FundCalculatedDataItem.IndicatorType.VOLATILIDADE):
        value = StandardDeviation.compute(fundContainer, benchContainer, periodType, fundCalculatedData.date, 1)
    elif(indicatorType == FundCalculatedDataItem.IndicatorType.BETA):
        value = Beta.compute(fundContainer, benchContainer, periodType, fundCalculatedData.date, 1)
        

    #NAO CONSEGUIU CALCULAR
    if(value == None):
        return None
        
    return FundCalculatedDataItem(fundCalculatedData, indicatorType, periodType, value, benchId)

