'''
@author: jose.corsini
'''
from calculators.SerieContainer import SerieContainer
import math
from util.FundCalculatedDataItem import FundCalculatedDataItem

#Computa o indicador Retorno
def compute(fundContainer, benchContainer, periodType, date):
   
    quotaList = fundContainer.quotaList
    size = len(quotaList)
    if(size == 0):
        print "FUNDO SEM COTAS"
        return None
    
    #Encontra a posicao da data
    end = date      
    if(quotaList[size-1].date < end):
        print "COTA FINAL ANTERIOR A DATA DE ESTUDO"
        return None
    
    position = size - 1
    endQuota = quotaList[position]
    
    #Encontra a ultima cota
    while(endQuota.date > end and position >= 0):
        endQuota = quotaList[position]
        position = position -1
    
    #Verifica se encontrou a ultima posicao
    if(position < 0):
        print "PRIMEIRA COTA POSTERIOR A DATA DE ESTUDO"
        return None
    
    #Encontra a primeira posicao
    initialPosition = position - periodType

    #Encontra a primeira cota
    firstQuota = None
    if(initialPosition < 0):
        print "QUANTIDADE DE DADOS INSUFICIENTE"
        return None
    else:
        firstQuota = quotaList[initialPosition]  
        
    return math.log(endQuota.value/firstQuota.value) 

#Computa a serie do indicador retorno
def computeSerie(fundContainer, benchContainer, periodType, date, window):

    dates = [] 
    values = []
    
    quotaList = fundContainer.quotaList
    size = len(quotaList)
    if(size == 0):
        print "FUNDO SEM COTAS"
        return None
    
    #Encontra a posicao da data
    end = date
    if(quotaList[size-1].date < end):
        print "COTA FINAL ANTERIOR A DATA DE ESTUDO"
        return None
    
    position = size - 1
    lastQuota = quotaList[position]
    
    #Encontra a ultima cota
    while(lastQuota.date > end and position >= 0):
        position = position - 1
        lastQuota = quotaList[position]
        
    
    #Verifica se encontrou a ultima posicao
    if(position < 0):
        print "PRIMEIRA COTA POSTERIOR A DATA DE ESTUDO"
        return None
    
    #Calcula retornos ate primeira posicao
    daysToComeBack = periodType

    while(daysToComeBack > 0 ):
        windowPosition = position - window
        #Se ja atingiu o limite de janela
        if(windowPosition < 0):
            break
        
        windowQuota = quotaList[windowPosition]
        dates.append(lastQuota.date)
        values.append(math.log(lastQuota.value / windowQuota.value))
        
        #Atualizacao Posicao
        position = position - 1
        lastQuota = quotaList[position]
        daysToComeBack = daysToComeBack - 1
        
    
    return SerieContainer(dates,values,FundCalculatedDataItem.IndicatorType.RETORNO)

#Computa a serie de retornos de um benchmark
def computeBenchSerie(fundContainer, benchContainer, periodType, date, window):

    dates = [] 
    values = []
    
    valuesList = benchContainer.valuesList
    size = len(valuesList)
    if(size == 0):
        print "FUNDO SEM COTAS"
        return None
    
    #Encontra a posicao da data
    end = date
    if(valuesList[size-1].date < end):
        print "COTA FINAL ANTERIOR A DATA DE ESTUDO"
        return None
    
    position = size - 1
    lastQuota = valuesList[position]
    
    #Encontra a ultima cota
    while(lastQuota.date > end and position >= 0):
        position = position - 1
        lastQuota = valuesList[position]
        
    
    #Verifica se encontrou a ultima posicao
    if(position < 0):
        print "PRIMEIRA COTA POSTERIOR A DATA DE ESTUDO"
        return None
    
    #Calcula retornos ate primeira posicao
    daysToComeBack = periodType 

    while(daysToComeBack > 0 ):
        windowPosition = position - window
        #Se ja atingiu o limite de janela
        if(windowPosition < 0):
            break
        
        windowQuota = valuesList[windowPosition]
        dates.append(lastQuota.date)
        values.append(math.log(lastQuota.value / windowQuota.value))
        
        #Atualizacao Posicao
        position = position - 1
        lastQuota = valuesList[position]
        daysToComeBack = daysToComeBack - 1
        
    
    return SerieContainer(dates,values,FundCalculatedDataItem.IndicatorType.RETORNO)
