'''
@author: jose.corsini
'''
from web import UserFilesController
from cluster.ClusterItem import ClusterItem
from util import AnalysisExporter
from cluster import ClusterBuilder

#Processa um cluster para um determinado usuario e numero de centros
def processCluster(username, centers):
    items = []
    f = open(UserFilesController.getClusterUploadedFilePath(username), 'r')
    lines = f.readlines()
    f.close()

    #Cria o item do container    
    for i in range(len(lines)):
        lin = lines[i]
        aux = lin.split(';')
        items.insert(i,ClusterItem(aux[0], float(aux[1]), float(aux[2])))
    
    #Constroi o cluster
    outputContainer = ClusterBuilder.buildCluster(username, items, int(centers), 'kmeans','subtitulo','eixoX','eixoY')
    
    #Exporta a analise
    AnalysisExporter.exportClusterAnalysis(username, outputContainer)
    
    
    return outputContainer 
    