'''
@author: jose.corsini
'''
from pyper import R
from web import UserFilesController

#Cria uma dispersao no R a partir de um container
def buildDispersion(items, title, subtitle, xLabel, yLabel, includeOutliers, outputContainer):
    
    myR = R()

    x = []
    y = []
    preservedCNPJ = []
    removedCNPJ = []
    
    #Decide se inclui outliers ou nao
    if(includeOutliers == True):
        for i in range(len(items)):
            x.insert(i, items[i].xValue)
            y.insert(i, items[i].yValue)
    else:
        aux = 0
        aux2 = 0
        for i in range(len(items)):
            if(items[i].outlier == False):
                x.insert(aux, items[i].xValue)
                y.insert(aux, items[i].yValue)
                preservedCNPJ.insert(aux, items[i].cnpj)
                aux = aux + 1
            else:
                removedCNPJ.insert(aux2, items[i].cnpj)
                aux2 = aux2 + 1
        
        outputContainer.preservedCNPJ = preservedCNPJ
        outputContainer.removedCNPJ = removedCNPJ
    
    myR[xLabel] = x
    myR[yLabel] = y
  
    plot ='plot(' + xLabel + ',' + yLabel + ', main="' + title + '", sub="' + subtitle + '")'
    
    #Gera um arquivo de saida
    outputPath = UserFilesController.generateRandomOutputFilePath(outputContainer.username, '.png')
    
    if(includeOutliers == True):
        outputContainer.preImage = outputPath
    else:
        outputContainer.posImage = outputPath
         
    output = "png('" + outputPath + "')"
    
    #Plota o grafico
    myR.run(output) 
    myR.run(plot)
