'''
@author: jose.corsini
'''
import numpy

#Aplica o filtro com a distancia de Mahalanobis, para um determinado grupo de items e fator
def applyFilter(items, factor):
    
    x = []
    y = []
    n = len(items)
    
    #Constroi vetores com os valores 
    i = 0
    for i in range(len(items)):
        item = items[i]
        x.insert(i,item.xValue)
        y.insert(i,item.yValue) 
     
   
    #Matrix de correlacao. Usa apenas 3 variaveis para descrever as 3 posicoes de uma matriz 2x2
    # |  a   b  |
    # |__b   c__|
    a = 0.0
    b = 0.0
    c = 0.0
    for i in range(len(items)):
        a = a + x[i] * x[i]
        b = b + x[i] * y[i]
        c = c + y[i] * y[i]
    
    a = a/n
    b = b/n
    c = c/n
    
    det = (a * c) - (b * b)
    # INVERSE / det
    #  __     __
    # |  d   e  |
    # |__e   f__|
    d = c / det
    e = (-1.0 * b) / det
    f = a / det
    
    #Distancias calculadas
    xAverage = numpy.average(x)
    yAverage = numpy.average(y)
    dist = []
    for i in range(len(items)):
        auxX = x[i] - xAverage
        auxY = y[i] - yAverage
        xr = auxX * d + auxY * e
        yr = auxX * e + auxY * f
        dist.insert(i, numpy.sqrt(auxX * xr + auxY * yr))
        
    
    #Distancia media
    dAverage = numpy.average(dist)
    
    #Deteccao de outliers
    for i in range(len(items)):
        if(dist[i] > factor * dAverage):
            items[i].outlier = True
        
    
    
    
    

    
    

    