'''
@author: jose.corsini
'''
from mahalanobis.MahalanobisItem import MahalanobisItem
from mahalanobis import MahalanobisFilter
from graphicsR import DispersionBuilder
from web import UserFilesController
from mahalanobis.MahalanobisOutput import MahalanobisOutput
from util import AnalysisExporter

#Processa a remocao de outliers para um determinado usuario e um determinado fator
def processMahalanobis(username, factor):
    
    #Abre o arquivo
    items = []
    f = open(UserFilesController.getMahalanobisUploadedFilePath(username), 'r')
    lines = f.readlines()
    f.close()

    #Constroi os items
    for i in range(len(lines)):
        lin = lines[i]
        aux = lin.split(';')
        items.insert(i,MahalanobisItem(aux[0], float(aux[1]), float(aux[2])))
    
    #Aplica o filtro
    MahalanobisFilter.applyFilter(items, float(factor))
    
    #Gera o container de saida
    outputContainer = MahalanobisOutput(username) 
    
    #Cria a dispersao para cada um dos casos, pre e pos
    DispersionBuilder.buildDispersion(items, 'PRE-MAHALANOBIS', '', 'eixoX', 'eixoY', True, outputContainer);
    DispersionBuilder.buildDispersion(items, 'POS-MAHALANOBIS', 'Fator = ' + factor, 'eixoX', 'eixoY', False, outputContainer);
    #Exporta a analise
    AnalysisExporter.exportMahalanobisAnalysis(username, outputContainer)
    
    
    return outputContainer
    
