'''
@author: jose.corsini
'''
import os
import random
#Classe que controla os arquivos de manipulacao do usuario ou do sistema
class FileType:
    MAHALANOBIS_UPLOAD = 'mahalanobis_upload.txt'
    MAHALANOBIS_PRE_IMG = 'mahalanobis_pre_img.png'
    MAHALANOBIS_POS_IMG = 'mahalanobis_pos_img.png'
    CLUSTER_UPLOAD = 'cluster_upload.txt'
    INDEX_UPLOAD = 'index_upload.txt'
    REPORT_PARAMETERS_UPLOAD = 'report_parameters.txt'

#Cria diretorios para um determinado usuario
def createDirectories(username):
    if(os.path.exists(getUploadPath(username))):
        removeDir(getUploadPath(username))
    if(os.path.exists(getOutputPath(username))):
        removeDir(getOutputPath(username)) 
        
    os.mkdir(getUploadPath(username))
    os.mkdir(getOutputPath(username))
    

#Remove diretorios para um usuario
def removeDirectories(username):
    removeDir(getUploadPath(username))
    removeDir(getOutputPath(username))

#Remove um diretorio e arquivos
def removeDir(path):
    for (path, dirs, files) in os.walk(path):
        for d in dirs:
            os.removedirs(path + d)
        for f in files:
            os.remove(path + f)
    os.removedirs(path)    

#Salva um arquivo de upload
def saveUserUploadedFile(username, userfile, filetype):
    userfile.save(getUploadPath(username) + filetype)
    
#Salva uma imagem como output
def saveImageAsOutput(username, originalImage, filetype):
    output = open(getOutputPath(username)+filetype,'wb')
    output.write(originalImage.read())
    output.close()
        
#Busca o arquivo de remocao de outliers para um usuario
def getMahalanobisUploadedFilePath(username):        
    return getUploadPath(username) + FileType.MAHALANOBIS_UPLOAD

#Busca o arquivo de classificacao para um usuario
def getClusterUploadedFilePath(username):        
    return getUploadPath(username) + FileType.CLUSTER_UPLOAD

#Busca o arquivo de indexadores a serem alimentados
def getIndexUploadedFilePath(username):        
    return getUploadPath(username) + FileType.INDEX_UPLOAD

#Busca o arquivo de relatorios para um usuario
def getReportParametersUploadedFilePath(username):        
    return getUploadPath(username) + FileType.REPORT_PARAMETERS_UPLOAD
    
#Busca o diretorio de upload de um usuario
def getUploadPath(username):
    return 'static/uploads/'+ username + '/'

#Busca o diretorio de saida de um usuario
def getOutputPath(username):
    return 'static/output/'+ username + '/'

#Gera um nome de arquivo aleatorio a ser guardado
def generateRandomOutputFilePath(username, extension):
    return 'static/output/'+ username + '/' + str(random.randint(0,1000000000000000)) + extension

