package br.gov.cvm.webServices;

public interface WsDownloadInfsSoap extends java.rmi.Remote {

	/**
	 * Verifica credenciais e efetua o login no CVMWeb.
	 */
	public void login(int iNrSist, String strSenha) throws java.rmi.RemoteException;

	/**
	 * Retorna um array de strings contendo as datas de competncias de
	 * documentos entregues a partir de determinada data.
	 */
	public String[] retornaListaComptcDocs(int iCdTpDoc, String strDtIniEntregDoc)
			throws java.rmi.RemoteException;

	/**
	 * Retorna um array de strings contendo as datas de competncias de
	 * documentos entregues a partir de determinada data e CNPJ de participante.
	 */
	public String[] retornaListaComptcDocsPartic(int iCdTpDoc, String strDtIniEntregDoc,
			String strNrPfPj) throws java.rmi.RemoteException;

	/**
	 * Retorna um array de strings contendo as datas de competncias de
	 * documentos entregues a partir de determinada data e CNPJ de administrador
	 */
	public String[] retornaListaComptcDocsAdm(int iCdTpDoc, String strDtIniEntregDoc,
			String strNrPfPj) throws java.rmi.RemoteException;

	/**
	 * Verifica autorizao para download e retorna string contendo URL para
	 * download de arquivo (referncia DtComptcDoc).
	 */
	public String solicAutorizDownloadCadastro(String strDtRefer,
			String strMotivoAutorizDownload) throws java.rmi.RemoteException;

	/**
	 * Verifica autorizao para download e retorna string contendo URL para
	 * download de arquivo (referncia DtComptcDoc).
	 */
	public String solicAutorizDownloadArqComptc(int iCdTpDoc, String strDtComptcDoc,
			String strMotivoAutorizDownload) throws java.rmi.RemoteException;

	/**
	 * Verifica autorizao para download e retorna string contendo URL para
	 * download de arquivo (referncia DtEntregaDoc)
	 */
	public String solicAutorizDownloadArqEntrega(int iCdTpDoc, String strMotivoAutorizDownload)
			throws java.rmi.RemoteException;

	/**
	 * Verifica autorizao para download e retorna string contendo URL para
	 * download de arquivo (referncia DtEntregaDoc)
	 */
	public String solicAutorizDownloadArqEntregaPorData(int iCdTpDoc, String strDtEntregaDoc,
			String strMotivoAutorizDownload) throws java.rmi.RemoteException;

	/**
	 * Verifica autorizao para download e retorna string contendo URL para
	 * download de arquivo (referncia PeriodoAnual)
	 */
	public String solicAutorizDownloadArqAnual(int iCdTpDoc, String strMotivoAutorizDownload)
			throws java.rmi.RemoteException;

	/**
	 * Retorna a data limite de entrega de documentos (pelos administradores)
	 * que foram considerados na gerao dos arquivos compactados, atualmente
	 * disponveis no servidor.
	 */
	public String retornaDtLmtEntrDocsArqsDisp(int iCdTpDoc) throws java.rmi.RemoteException;

}
