package br.org.usp.ime.corsini.robot.collector;

import java.util.Date;
import java.util.List;

import javax.persistence.Query;

import br.org.usp.ime.corsini.robot.loader.entities.Benchmark;
import br.org.usp.ime.corsini.robot.loader.entities.BenchmarkValue;
import br.org.usp.ime.corsini.robot.persistence.EntityManagerHelper;

/**
 * @author jose.corsini
 *
 */
public class BenchmarkLoader {

	private final Query benchmarkQuery = Benchmark.getQueryFindBySymbol();

	private final Query benchmarkValueQuery = BenchmarkValue.getQueryFindByBenchmarkAndDate();

	
	/**
	 * Persiste o valor de um ndice
	 * @param symbol: simbolo do indice
	 * @param d: data
	 * @param v: valor
	 */
	@SuppressWarnings("unchecked")
	protected void persistValue(String symbol, Date d, Double v)
	{
		EntityManagerHelper.startTransaction();

		//Busca o benchmark
		benchmarkQuery.setParameter("symbol", symbol);
		List<Benchmark> result = benchmarkQuery.getResultList();
		if(result == null || result.size() == 0)
		{
			return;
		}

		Benchmark bench = (Benchmark) result.get(0);

		BenchmarkValue bv = new BenchmarkValue();
		bv.setBenchmark(bench);
		bv.setDate(d);
		bv.setValue(v);

		//Valida
		if(bv.validate())
		{
			benchmarkValueQuery.setParameter("benchmark", bv.getBenchmark());
			benchmarkValueQuery.setParameter("date", bv.getDate());
			List<BenchmarkValue> resultValue = benchmarkValueQuery.getResultList();
			//Se  novo, persiste. Se  antigo, atualiza
			if(resultValue == null || resultValue.size() == 0)
			{
				EntityManagerHelper.persist(bv);	
			}else
			{
				BenchmarkValue old = resultValue.get(0);
				if(!old.equals(bv))
				{
					old.setValue(bv.getValue());
					EntityManagerHelper.merge(old);
				}
			}
		}


		EntityManagerHelper.flushAndEndTransaction();


	}

}
