package br.org.usp.ime.corsini.robot.loader.entities;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Query;
import javax.persistence.Table;

import br.org.usp.ime.corsini.robot.persistence.EntityManagerHelper;

/**
 * Entity implementation class for Entity: Fund
 *
 */
@Entity
@Table(name = "benchmark")
@NamedQueries(value = {
		@NamedQuery(name = "Benchmark.findBySymbol", query = "select b from Benchmark b where b.symbol = :symbol")})
public class Benchmark implements Serializable {

	private static final long serialVersionUID = 5293454481112210052L;
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private int id;
	
	@Column(nullable = false)
	private String symbol;
	
	@Column(nullable = false)
	private String description;	
	
	public Benchmark()
	{
		
	}
	
	public static Query getQueryFindBySymbol()
	{
		return EntityManagerHelper.getQuery("Benchmark.findBySymbol");
	}

	public Benchmark(String symbol, String description) {
		this.symbol = symbol;
		this.description = description;
	}

	public String getSymbol() {
		return symbol;
	}

	public void setSymbol(String symbol) {
		this.symbol = symbol;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public int getId() {
		return id;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((description == null) ? 0 : description.hashCode());
		result = prime * result + ((symbol == null) ? 0 : symbol.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Benchmark other = (Benchmark) obj;
		if (description == null) {
			if (other.getDescription() != null)
				return false;
		} else if (!description.equals(other.getDescription()))
			return false;
		if (symbol == null) {
			if (other.getSymbol() != null)
				return false;
		} else if (!symbol.equals(other.getSymbol()))
			return false;
		return true;
	}
	
	
	
	
	
	

	
	
	
	
}