package br.org.usp.ime.corsini.robot.main;

import java.util.Date;

import org.quartz.JobDetail;
import org.quartz.Scheduler;
import org.quartz.SimpleTrigger;
import org.quartz.impl.StdSchedulerFactory;


/**
 * @author jose.corsini
 *
 */
public class RobotRunner {
	
	//repete a cada 12 horas
	private static Long INTERVAL = Long.valueOf(43200000);
	
    public static void main(String[] args) {
        try {
        	
           	JobDetail job = new JobDetail();
        	job.setName("ROBOT");
        	job.setJobClass(RobotJob.class);
     
        	//configure the scheduler time
        	SimpleTrigger trigger = new SimpleTrigger("ROBOT TRIGGER");
        	trigger.setStartTime(new Date(System.currentTimeMillis() + 1000));
        	trigger.setRepeatCount(SimpleTrigger.REPEAT_INDEFINITELY);
        	trigger.setRepeatInterval(INTERVAL);
     
        	//schedule it
        	Scheduler scheduler = new StdSchedulerFactory().getScheduler();
        	scheduler.start();
        	scheduler.scheduleJob(job, trigger);
        	
        } catch (Exception e) {
            System.out.println("erro");
            e.printStackTrace();
        }
    }
}
