package br.org.usp.ime.corsini.robot.persistence;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.Query;

/**
 * @author jose.corsini
 *
 */
public class EntityManagerHelper {

	//Cria um EntityManagerFactory
	private static final EntityManagerFactory factory = Persistence.createEntityManagerFactory("cvm-fund-info-robot");

	private static EntityManager em;

	private static EntityTransaction transaction;


	/**
	 * Inicia uma transao
	 */
	public static void startTransaction()
	{
		em = factory.createEntityManager();
		transaction = em.getTransaction();
		transaction.begin();
	}

	/**
	 * Flush e encerra a transao
	 */
	public static void flushAndEndTransaction()
	{
		em.flush();
		transaction.commit();
	}

	/**
	 * Persiste
	 * @param o
	 */
	public static void persist(Object o)
	{
		em.persist(o);  
	}

	/**
	 * Atualiza
	 * @param o
	 */
	public static void merge(Object o)
	{
		em.merge(o);  
	}

	/**
	 * Busca uma query a partir da namedQuery
	 * @param namedQuery
	 * @return
	 */
	public static Query getQuery(String namedQuery)
	{
		EntityManager em = factory.createEntityManager();
		return em.createNamedQuery(namedQuery);
	}


}
