/*

SQLyog Ultimate v8.55 
MySQL - 5.5.22 : Database - cvm_fund_info

*********************************************************************

*/



/*!40101 SET NAMES utf8 */;



/*!40101 SET SQL_MODE=''*/;



/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;

/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

CREATE DATABASE /*!32312 IF NOT EXISTS*/`cvm_fund_info` /*!40100 DEFAULT CHARACTER SET latin1 */;



USE `cvm_fund_info`;



/*Table structure for table `benchmark` */



DROP TABLE IF EXISTS `benchmark`;



CREATE TABLE `benchmark` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `symbol` varchar(50) NOT NULL,
  `description` varchar(200) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;



/*Data for the table `benchmark` */



/*Table structure for table `benchmark_value` */



DROP TABLE IF EXISTS `benchmark_value`;



CREATE TABLE `benchmark_value` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `benchmark_id` int(11) NOT NULL,
  `date` date NOT NULL,
  `value` double NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_benchmark_value` (`benchmark_id`),
  CONSTRAINT `FK_benchmark_value` FOREIGN KEY (`benchmark_id`) REFERENCES `benchmark` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1089 DEFAULT CHARSET=latin1;



/*Data for the table `benchmark_value` */



/*Table structure for table `fund` */



DROP TABLE IF EXISTS `fund`;



CREATE TABLE `fund` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cnpj` bigint(20) NOT NULL,
  `name` varchar(300) NOT NULL,
  `start_date` date NOT NULL,
  `category` varchar(100) NOT NULL,
  `category_start` date DEFAULT NULL,
  `exclusive` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=12498 DEFAULT CHARSET=latin1;



/*Data for the table `fund` */



/*Table structure for table `fund_calculated_data` */



DROP TABLE IF EXISTS `fund_calculated_data`;



CREATE TABLE `fund_calculated_data` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `fund_id` int(11) NOT NULL,
  `date` date NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_fund_calculated_data` (`fund_id`),
  CONSTRAINT `FK_fund_calculated_data` FOREIGN KEY (`fund_id`) REFERENCES `fund` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5456 DEFAULT CHARSET=latin1;



/*Data for the table `fund_calculated_data` */



/*Table structure for table `fund_calculated_data_item` */



DROP TABLE IF EXISTS `fund_calculated_data_item`;



CREATE TABLE `fund_calculated_data_item` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `calculated_data_id` int(11) NOT NULL,
  `indicator_type` varchar(50) NOT NULL,
  `period_type` varchar(50) NOT NULL,
  `value` double NOT NULL,
  `benchmark_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_fund_calculated_data_item` (`calculated_data_id`),
  KEY `FK_fund_calculated_data_item_bench` (`benchmark_id`),
  CONSTRAINT `FK_fund_calculated_data_item` FOREIGN KEY (`calculated_data_id`) REFERENCES `fund_calculated_data` (`id`),
  CONSTRAINT `FK_fund_calculated_data_item_bench` FOREIGN KEY (`benchmark_id`) REFERENCES `benchmark` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=13850 DEFAULT CHARSET=latin1;



/*Data for the table `fund_calculated_data_item` */



/*Table structure for table `fund_quota` */



DROP TABLE IF EXISTS `fund_quota`;



CREATE TABLE `fund_quota` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `fund_id` int(11) NOT NULL,
  `date` date NOT NULL,
  `quota` double NOT NULL,
  `net_asset` double NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_fund_quota` (`fund_id`),
  CONSTRAINT `FK_fund_quota` FOREIGN KEY (`fund_id`) REFERENCES `fund` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3885924 DEFAULT CHARSET=latin1;



/*Data for the table `fund_quota` */



/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;

/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;

/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;

/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

